#define USB_PID_NULL            0x00    /* reserved PID */
#define USB_PID_SOF             0x05
#define USB_PID_SETUP           0x0D
#define USB_PID_IN              0x09
#define USB_PID_OUT             0x01
#define USB_PID_ACK             0x02
#define USB_PID_NAK             0x0A
#define USB_PID_STALL           0x0E
#define USB_PID_DATA0           0x03
#define USB_PID_DATA1           0x0B
#define USB_PID_PRE             0x0C

typedef struct _USB_SETUP_REQ 
{
  uint8_t bRequestType;
  uint8_t bRequest;
  uint8_t wValueL;
  uint8_t wValueH;
  uint8_t wIndexL;
  uint8_t wIndexH;
  uint8_t wLengthL;
  uint8_t wLengthH;
} USB_SETUP_REQ, *PUSB_SETUP_REQ;

typedef struct _USB_CONFIG_DESCR_LONG 
 {
    ConfigurationDescriptor cfg_descr;
    InterfaceDescriptor     itf_descr;
    EndpointDescriptor      endp_descr[1]; //at least one ep descr which is wrong
} USB_CFG_DESCR_LONG, *PUSB_CFG_DESCR_LONG;
